#ifndef TAS_H
#define TAS_H

#include <sys/time.h>
#include "atomic_ops.h"
#include "main.h"
#include "inline.h"

typedef volatile unsigned long tatas_lock;

extern void tatas_acquire_slowpath(tatas_lock *L);
extern bool tatas_timed_acquire_slowpath(tatas_lock *L, hrtime_t T);

#define TATAS_ACQUIRE_BODY \
    if (tas(L)) { \
        tatas_acquire_slowpath(L); \
    }

#define TATAS_TIMED_ACQUIRE_BODY \
    if (tas(L)) { \
        return tatas_timed_acquire_slowpath(L, T); \
    } else { \
        return true; \
    }

#define TATAS_RELEASE_BODY \
    *L = 0;

INLINE void tatas_acquire(tatas_lock *L)
BODY({TATAS_ACQUIRE_BODY})

INLINE bool tatas_timed_acquire(tatas_lock *L, hrtime_t T)
BODY({TATAS_TIMED_ACQUIRE_BODY})

INLINE void tatas_release(tatas_lock *L)
BODY({TATAS_RELEASE_BODY})

#endif
